import { ActivatedRouteSnapshot, Router, RouterStateSnapshot } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { BehaviorSubject } from 'rxjs';
import { MonkeyEcxErrorResponse, MonkeyEcxHandledErrorResponse, MonkeyEcxRequestPaged, MonkeyEcxRequestSchedule, MonkeyEcxResponsePaged, MonkeyEcxTokenCredentials, MonkeyEcxTranslateOptions } from '../../interfaces';
import { MonkeyEcxTokenStorageService } from '../storage/monkeyecx-token-storage.service';
import { MonkeyEcxRequestScheduleService } from '../schedules/monkeyecx-request-schedule.service';
import { MonkeyEcxRequestQueueHandlingService } from '../request-queue/monkeyecx-request-queue-handling.service';
import { MonkeyEcxFeatureToggleService } from '../config/monkeyecx-feature-toggle.service';
import { MonkeyEcxService } from '../monkeyecx-service.service';
export declare class MonkeyEcxCommonsService {
    monkeyecxService?: MonkeyEcxService | undefined;
    tokenStorage?: MonkeyEcxTokenStorageService | undefined;
    otherArgs?: {
        router?: Router | undefined;
        schedule?: {
            service: MonkeyEcxRequestScheduleService;
            options?: {
                clearOnChangeRoute?: boolean | undefined;
            } | undefined;
        } | undefined;
        queue?: {
            service: MonkeyEcxRequestQueueHandlingService;
        } | undefined;
    } | undefined;
    private flagValidator;
    __data: any | any[];
    __params: any | any[];
    __error: MonkeyEcxErrorResponse | null;
    __handledError: MonkeyEcxHandledErrorResponse | null;
    __page: MonkeyEcxResponsePaged | null;
    __search: any;
    __requestPaged: MonkeyEcxRequestPaged | null;
    __onSearchChanged$: BehaviorSubject<any>;
    __onDataChanged$: BehaviorSubject<any>;
    __onLoadingInProgress$: BehaviorSubject<any>;
    __onDataDeleted$: BehaviorSubject<any>;
    __onErrorChanged$: BehaviorSubject<any>;
    __onGovernmentIdDataChanged$: BehaviorSubject<any>;
    __onZipCodeDataChanged$: BehaviorSubject<any>;
    __oni18nDataChanged$: BehaviorSubject<any>;
    __onDoSearch$: BehaviorSubject<MonkeyEcxRequestPaged>;
    __onDoPagination$: BehaviorSubject<any>;
    __tokenCredentials: MonkeyEcxTokenCredentials | null;
    __schedule: MonkeyEcxRequestSchedule | null;
    __i18n: any;
    constructor(monkeyecxService?: MonkeyEcxService | undefined, tokenStorage?: MonkeyEcxTokenStorageService | undefined, otherArgs?: {
        router?: Router | undefined;
        schedule?: {
            service: MonkeyEcxRequestScheduleService;
            options?: {
                clearOnChangeRoute?: boolean | undefined;
            } | undefined;
        } | undefined;
        queue?: {
            service: MonkeyEcxRequestQueueHandlingService;
        } | undefined;
    } | undefined);
    private handleInit;
    private getRole;
    private allowedSecurityAccess;
    private navigateToErrorPage;
    setPage(requestPaged: MonkeyEcxRequestPaged): this;
    nextPage(): boolean;
    getEmbeddedData(data: any, field: string): any[] | any;
    getNormalizedUrl(url: string): string;
    clear(clearData: boolean): void;
    resolve(route: ActivatedRouteSnapshot | null, state: RouterStateSnapshot | null, otherArgs?: {
        callbackMain: Function;
        router?: Router;
        security?: {
            roles: string[];
            byExclusion?: boolean;
        };
        callbackPagination?: Function;
        translateOptions?: MonkeyEcxTranslateOptions;
        feature?: {
            service: MonkeyEcxFeatureToggleService;
            flag: string;
        };
    }): void;
    getHTTPHeaderApplicationPDF(): Object;
    genericMethod(link: any, data?: any, callback?: Function): void;
    geti18n(translateService: TranslateService, keys: string | string[]): void;
}
